#include<math.h>
#include<iostream>
#include<fstream>

#include<stdio.h>
#include<unistd.h>
#include<fcntl.h>
#include<sys/ioctl.h>
#include<linux/soundcard.h>


using namespace std;

#include "Ton.h"

int main()
{
    long int anzahl_samples = 44100;
    Ton ton(anzahl_samples);
    Ton ton2(anzahl_samples);
    Ton ton3(anzahl_samples);

    double f1 = 441;
    double f2 = 882;

    double dt = 1.0/44100.0;
    double  t = 0.0;

    for(int i=0;i<anzahl_samples;i++)
    {
        ton.setLinks(i,0.0);
        ton.setRechts(i,0.0);
        t+=dt;
    }
    t = 0.0;
    for(int i=0;i<44100;i++)
    {
        ton.setLinks(i,0.9*sin(2.0*M_PI*f1*t));
        ton.setRechts(i,0.9*cos(2.0*M_PI*f1*t));
        ton3.setLinks(i,0.9*sin(2.0*M_PI*f2*t));
        ton3.setRechts(i,0.9*sin(2.0*M_PI*f2*t));
        t+=dt;
    }

    ton.speicher("sinus2.wav");   
    ton2.lade("sinus2.wav");   
    ton2.speicher("sinus3.wav");   

    //Ergnzungen fr die Verwendung des Audio-Devices unter Linux:
    ton.oeffneAudio();
    cout<<"Sinuston mit 441Hz abspielen."<<endl;
    ton.schreibePuffer();
    ton.abspielen();

    //Signal testweise nur ber 4-Byte-Puffer ausgeben:
    t = 0.0;
    for(int i=0;i<44100;i++)
    {
        ton.setLinks(i,0.9*sin(2.0*M_PI*f2*t));
        ton.setRechts(i,0.9*cos(2.0*M_PI*f2*t));
        t+=dt;
    }
    ton.schreibePuffer();
    ton.abspielen_test();


    ton.aufnehmen();
    ton.lesePuffer();
    ton.schreibePuffer();
    ton.abspielen();


    ton.schliesseAudio();    
}
